#include "cseslib.hpp"
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

int main()
{
    vector<long long> v = read_ints(2, 0, 1000000000);
    long long n = v[0];
    long long _k = v[1];
    if (n < 1 || n > 100) fail();
    if (_k > n * (n - 1) / 2) fail();

    vector<int> g;
    if (n <= 4) g.push_back(1);
    if (_k == n * (n - 1) / 2) g.push_back(2);
    if (_k == 0) g.push_back(3);
    if (_k <= n) g.push_back(4);
    if (_k <= n * (n - 1) / 8) g.push_back(5);
    g.push_back(6);
    end_groups(g);
}
